import com.ET199.*;
import java.io.*;

public class ET199test
{
	public static void main(String args[])
	{
		try
		{
			System.out.println("et199 test begin...");
			//Enumerate the number et199 
			System.out.println("\nEnumerate the number et199 ...");
			int nDevCount = ET199.Enum();
			System.out.println(nDevCount);
			
			//(2)Open the index is 0 et199
			System.out.println("\nOpen the index is 0 et199...");
			ET199 et = new ET199(0);
			displayDeviceInfo(et);
				                
			byte[] byDevPinDefault = 
			{
	                    0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38,
	                    0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38,
	                    0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38
               		 };
			try
			{
				//(3)Switch to root dierectory
				System.out.println("\nSwitch to root dierectory..");
				et.ChangeDir("\\");
				//(4)Verify developer pin
				System.out.println("\nVerify developer pin..");
				et.VerifyPin(byDevPinDefault,ET199.ET_DEV_PIN);
				//(5)Delete root directory
				System.out.println("\nDelete root directory..");
				et.EraseDir(null);
			}
			catch(ET_EXCEPTION e)
			{
				if(e.getExceptionCode() == et.ET_E_DIR_NOT_FOUND)
				{
					System.out.println("ET199 exception:"+e.getReason());
				}
				else
				{
					throw e;
				}
			}
			//(6)Create root directory
			System.out.println("\nCreate root directory..");
			et.CreateDir(null,0,ET199.ET_ROOT_DIR);
			
			//(7)Verify developer pin
			System.out.println("\nVerify developer pin...");
			et.VerifyPin(byDevPinDefault,ET199.ET_DEV_PIN);
			
			//(8)Set LED on
	                final int nLedFreq = 5;
	                byte[] byLedFreq = {(byte)nLedFreq, 0, 0, 0};
	                System.out.println("\nSet LED on,frequency is " + nLedFreq + "...");
	                et.Control(ET199.ET_LED_WINK, byLedFreq, 4, null, null);  
	                
			//(9)Create subdirectory
	                String strSubDirID = "5678";
	                System.out.println("\nCreate subdirectory,ID is "+strSubDirID+"...");
	                et.CreateDir(strSubDirID, 0x2000, ET199.ET_SUB_DIR);
	                
	                //(10)Change developer pin
	                System.out.println("\nChange developer pin..");
	                byte[] byDevPinNew = 	                
	                {
	                    0x31, 0x31, 0x31, 0x31, 0x31, 0x31, 0x31, 0x31,
	                    0x31, 0x31, 0x31, 0x31, 0x31, 0x31, 0x31, 0x31,
	                    0x31, 0x31, 0x31, 0x31, 0x31, 0x31, 0x31, 0x31
	                };
                	et.ChangePin(byDevPinDefault, byDevPinNew, ET199.ET_DEV_PIN, (byte)0xff);
                	
			//(11)Create executable file
			String strExeFileID = "1234";
			System.out.println("\nCreate executable file,ID is "+strExeFileID+"...");
			et.CreateFile(strExeFileID,0x1000,(byte)0);
			
			//(12)Write data to executable file
			System.out.println("\nWrite data to executable file"+strExeFileID + "...");
			writeExeFileData(et,strExeFileID,"hardware.c51");
			
			//(13)Verify user pin
			System.out.println("\nVerify user pin...");
			byte[] byUserPin = 	                
	                {
	                    0x31, 0x32, 0x33, 0x34, 0x35, 0x36, 0x37, 0x38
	                };
			et.VerifyPin(byUserPin,ET199.ET_USER_PIN);
			
			//(14)Run executable file
			System.out.println("\nRun executable file"+strExeFileID+"...");
			byte[] byOutBuffer = new byte[32];
			int[] nOutLen = new int[1];
			et.Execute(strExeFileID,null,0,byOutBuffer,nOutLen);
						
			//(15)Get file information

			System.out.println("\nGet file information...");			
			byte[] fi = new byte[5];
			fi[0] = 0x31;
			fi[1] = 0x32;
			fi[2] = 0x33;
			fi[3] = 0x34;
			int[] retlen = new int[1];
			et.Control(ET199.ET_GET_EF_INFO,fi,4,fi,retlen);
			
			//(16)Verify developer pin
	                System.out.println("\nVerify developer pin...");
	                et.VerifyPin(byDevPinNew, ET199.ET_DEV_PIN);
	                
			//(17)Create key pair
			byte[] byPubKeyData = new byte[1024];
			byte[] byPriKeyData = new byte[1024];
			int[] nPubKeyLen = new int[1];
			int[] nPriKeyLen = new int[1];
			System.out.println("\nCreate key pair...");
			et.GenRsaKey((short)1024,0x10001,"1111","2222",byPubKeyData,nPubKeyLen,byPriKeyData,nPriKeyLen);
			
			//(18)Switch to top-level directory
			System.out.println("\nSwitch to top-level directory..");
			et.ChangeDir("..");
			
			//(19)Reset device
	                System.out.println("\nReset device...");
	                int[] nBytesReturn = new int[1];
	                et.Control(ET199.ET_RESET_DEVICE, null, 0, null, nBytesReturn);
	
	                //(20)Verify developer pin
	                System.out.println("\nVerify developer pin...");
	                et.VerifyPin(byDevPinDefault, ET199.ET_DEV_PIN);
	
	                //(21)Delete root directory
	                System.out.println("\nDelete root directory...");
		            et.EraseDir(null);
	
	                //(22)Create root directory
	                System.out.println("\nCreate root directory...");
	                et.CreateDir("\\", 0, ET199.ET_ROOT_DIR);
	
	                //(23)Close device
	                System.out.println("\nClose device...");
		        et.Close();
	
	                System.out.println("\nET199 test end");
		}
		catch(ET_EXCEPTION e)
		{
			System.out.println("ET199 exception:" + e.getReason());
		}
		catch(Exception e)
		{
			System.out.println(e.getCause());
		}
	}
	private static void displayDeviceInfo(ET199 et)
	{
		int nVersion = et.GetVersion();
		System.out.print("Version:\t" + nVersion/256 + '.' );
		String strtemp = "00"+ String.valueOf((byte)nVersion);
		strtemp = strtemp.substring(strtemp.length()-2,strtemp.length());
		System.out.println( strtemp );
	
		System.out.println("Customer:\t" + Integer.toHexString(et.GetCustomer()));
		String str = new String(et.GetAtr());
		System.out.println("Atr:\t\t" + str);
		byte[] byID = et.GetID();
		System.out.print("ID:\t\t");
		for(int i=byID.length-1;i>=0;i--)
		{
			 System.out.print(Integer.toHexString(byID[i]) + " ");
		}
		System.out.println();		
	}
	private static void writeExeFileData(ET199 et,String strFileID,String strFilePath)throws FileNotFoundException,Exception
	{
		File f = new File(strFilePath);
		FileInputStream fs = new FileInputStream(f);
		if(f.length() > 10240)
		{
			throw new Exception("File size out of range");
		}
		byte[] data = new byte[(int)f.length()];
		fs.read(data);
		System.out.println("......");
		et.WriteFile(strFileID,0,data,(int)f.length());
	}	
}
